
/*
 * $Id: classi.c,v 1.5 1993/01/01 18:41:18 wade Exp $
 *
 * $Log: classi.c,v $
 * Revision 1.5  1993/01/01  18:41:18  wade
 * *** empty log message ***
 *
 * Revision 1.4  1993/01/01  16:37:33  wade
 * added con_help support
 *
 * Revision 1.3  1992/12/15  21:06:05  wade
 * using text instead of bitmaps for contextual help
 *
 * Revision 1.2  1992/12/05  17:15:51  larose
 * added rcs logging.
 *
 *
 */

#include "xnl.h"

/*LINTLIBRARY*/

int num_lines;

static void classSelect();
static Boolean classLoadList();


void classificationCB(w, call_data, client_data)
Widget w;
XtPointer call_data, client_data;
{
    Mode_desired = MODE_CLASSIFICATION;
}

Popup_classification(w)
Widget w;
{
    LibOrClass = Mode = MODE_CLASSIFICATION;

    grey_the_button(classificationButton, False);

    if (helpPic) {
        Arg args[3];
        XtSetArg(args[0], XtNstring, con_help[Mode]);
        XtSetValues (helpPic, args, 1);
    }

    XtManageChild(classPop);

    set_status(CLASS_HEADER, GREEN);
	return 1;
}

restart_class()
{
   register int i;

    for (i=0; mainClassList[i]; i++)
        XtFree(mainClassList[i]);
    for (i=0; mainclassFileList[i]; i++)
        XtFree(mainclassFileList[i]);

	make_class(toplevel);
}

make_class(w)
Widget w;
{
    Arg args[20];
    register int n;
    Boolean fileAvailable;
    char label[MAXLINE];

    if (classPop) { /* this is a restart */
        XtDestroyWidget(classPop);
    } else
		con_help[MODE_CLASSIFICATION] = "\n\
In Classification mode a set of interesting catagories are\n\
displayed. Click on one to see related libraries which are\n\
a subset of the top level libraries.\n";


    fileAvailable = classLoadList();

    n = 0;
    XtSetArg(args[n], XtNallowHoriz, True);        n++;
    XtSetArg(args[n], XtNallowVert, True);        n++;
    XtSetArg(args[n], XtNborderWidth, 0); n++;
    classPop = XtCreateWidget("classViewport", 
            viewportWidgetClass, topPane, args, n);

    if (fileAvailable) {
        n = 0;
        XtSetArg(args[n], XtNborderWidth, 0); n++;
        XtSetArg(args[n], XtNlist, mainClassList); n++;
        XtSetArg(args[n], XtNdefaultColumns, 2); n++;
		XtSetArg(args[n], XtNforceColumns, True); n++;
        classList = XtCreateManagedWidget("classList", 
                listWidgetClass, classPop, args, n);
        XtAddCallback(classList, XtNcallback,     
            classSelect, (XtPointer)NULL);
    } else {
        n = 0;
        XtSetArg(args[n], XtNborderWidth, 0); n++;
        sprintf(label, "couldn't find the class index %s/%s\n    press 'Set Up' to download index files", XNL_PATH, CLASS_FILE);
        XtSetArg(args[n], XtNlabel, label); n++;
        XtCreateManagedWidget("classList", 
                labelWidgetClass, classPop, args, n);
    }
    
    return 1;
}

Popdown_classification(w)
Widget w;
{
    grey_the_button(classificationButton, True);

    XtUnmanageChild(classPop);

    return 1;
}


static Boolean classLoadList()
{
    FILE *fp;
    char filename[MAXLINE];
    char line[MAXLINE];
    char name[MAXLINE], file[MAXLINE];
	register int i;

    num_lines = 0;

/*
    for (i=0; i < Many_servers; i++) {
ZZZ
*/
    i=0; {

		sprintf(filename, "%s/%s/%s", XNL_PATH, server_list[i], CLASS_FILE);


		confirmFile(filename, (PUBDATA) ? 1 : 0, False, False);

		/* first open the file and discover num_lines */
		fp = fopen(filename, "r");
		if (fp) {
				fgets(line, MAXLINE, fp); /* eat 1st 2 lines */
				fgets(line, MAXLINE, fp);
				while (fgets(line, MAXLINE, fp)) {
					line[ strlen(line) -1] = '\0';

					strcpy(name, line);
				

					if (plug_name(name, ':')) {
						name[ plug_name(name, ':') ] = '\0';
						strcpy(file, server_list[i]);
						strcat(file, "/");
						strcat(file, line + strlen(name) +1);
					} else {
						fprintf(stderr, "bad format, no ':' in <%s> line %d in <%s>\n",
							line, num_lines, filename);
						mainClassList[num_lines] = NULL;
						fclose(fp);
						return False;
					}

					mainClassList[num_lines] = XtNewString(name);
					mainclassFileList[num_lines] = XtNewString(file);
					num_lines++;
				}

				fclose(fp);

		}
	}
	/* NULL term */
	mainclassFileList[num_lines] =
	mainClassList[num_lines] = NULL;

	return True;
}

static void
classSelect(w, closure, call_data)
Widget w;
XtPointer closure, call_data;
{
    XawListReturnStruct *item = (XawListReturnStruct*)call_data;


    Popdown_classification(classificationButton);
    LastClassItem = item->list_index;
    Popup_classSelect(item->list_index);
}

